var externalapp_properties={

	rdf:null,
	resource:null,
  init: function(){
		this.rdf=new ExternalApplicationButtons();
		this.resource=this.rdf._rdfService.GetResource(gNodeid);
  },

  get _FFDir(){
    const directoryService=Components.classes['@mozilla.org/file/directory_service;1']
      .getService(Components.interfaces.nsIProperties);
    var fileOrDir = directoryService.get('CurProcD', Components.interfaces.nsIFile);
    var FFdir = fileOrDir.QueryInterface(Components.interfaces.nsILocalFile).path;
    FFdir += "\\"
    return FFdir
  },

  updateData : function (){

    var label    =document.getElementById("externalapp-settings-label").value;
    var path    =document.getElementById("externalapp-settings-path").value;
    if(document.getElementById("externalapp-set-path").checked)
	var ipath    =document.getElementById("externalapp-settings-image").value;
    else
	var ipath    =document.getElementById("externalapp-settings-path").value;
    var isize    ="?size=" + document.getElementById("externalapp-settings-image-size").value;
    if(/^(\.)/.test(ipath))
	var image    ="moz-icon:file:///" + this._FFDir.concat(ipath) + isize;
    else
	var image    ="moz-icon:file:///" + ipath + isize;
    var tooltiptext  =document.getElementById("externalapp-settings-tooltiptext").value;
    var key      =document.getElementById("externalapp-settings-key").value;
    var arguments  =document.getElementById("externalapp-settings-arguments").label;
		this.rdf.updateData(gNodeid,label,path,tooltiptext,ipath,isize,image,key,arguments);
    this.invalidateWindows();

  },

  showData : function (){
    
    this.setTextboxData("label");
    this.setTextboxData("path");
    this.setTextboxData("tooltiptext");
    this.setTextboxData2("image","ipath");
    this.setTextboxData("key");
    this.setMenuListData("arguments");
    if(this.rdf.getProperty(this.resource,"path")!=this.rdf.getProperty(this.resource,"ipath"))
	document.getElementById("externalapp-set-path").checked = true;
    else{
	document.getElementById('externalapp-settings-image').disabled=
	document.getElementById('externalapp-settings-image-button').disabled=true;
    }
    this.showImage();

  },

  showImage : function (){
    var url=this.rdf.getProperty(this.resource,"image");
    var size=document.getElementById("externalapp-settings-image-size");
    document.getElementById("externalapp-settings-image-image").src=url;
    //if(url.match(/^moz-icon:/)){
    //  size.disabled=false;

      if(url.match(/\?size=32/)) size.selectedIndex=1;
      else size.selectedIndex=0;
      
    //}else{
    //  size.selectedIndex=0;
    //  size.disabled=true;
    //}

  },

  setTextboxData : function (property){
    var textbox=document.getElementById("externalapp-settings-"+property);
    textbox.value = this.rdf.getProperty(this.resource,property);
  },

  setTextboxData2 : function (property,property2){
    var textbox=document.getElementById("externalapp-settings-"+property);
    textbox.value = this.rdf.getProperty(this.resource,property2);
  },

  setMenuListData : function (property){
    var menulist=document.getElementById("externalapp-settings-"+property);
    menulist.label = this.rdf.getProperty(this.resource,property);
  },

  selectFile : function(textboxid){
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
    fp.init(window, 'External Application', Components.interfaces.nsIFilePicker.modeOpen);
    fp.appendFilter("Applications(*.exe,*.bat)","*.exe;*.bat");
    fp.appendFilters(Components.interfaces.nsIFilePicker.filterAll);

    var ret = fp.show();
    if (ret == Components.interfaces.nsIFilePicker.returnOK) {
      var textbox = document.getElementById(textboxid);
      textbox.value = fp.fileURL.file.path;
      gDirty=true;
      externalapp_properties.freezeButton(!gDirty);
    }
  },


  selectImage : function(textboxid){
    var fp = Components.classes["@mozilla.org/filepicker;1"]
          .createInstance(Components.interfaces.nsIFilePicker);
    fp.init(window, 'Button icon', Components.interfaces.nsIFilePicker.modeOpen);
    fp.appendFilter("Image Files","*.png;*.jpg;*.bmp;*.gif;*.ico;*.mng;*.xbm;*.jpeg;*.xpm;*.dib;*.jif;*.jiff;*.jpe;*.exe");
    fp.appendFilters(Components.interfaces.nsIFilePicker.filterAll);

    var ret = fp.show();
    if (ret == Components.interfaces.nsIFilePicker.returnOK) {
      var textbox = document.getElementById(textboxid);
      var url=fp.fileURL.file.path;
      if(url.match(/\.exe$/i)||url.match(/\.ico$/i)) textbox.value=url;
      else textbox.value = url;
      gDirty=true;
      externalapp_properties.freezeButton(!gDirty);
      this.showImage();
    }
  },

  resizeImage : function(textboxid,imageid,menulistid){
    var textbox=document.getElementById(textboxid);
    var menulist=document.getElementById(menulistid);
    var image=document.getElementById(imageid);
    if(/^(\.)/.test(textbox.value))
	var url ="moz-icon:file:///" + this._FFDir.concat(textbox.value) + "?size=" + menulist.value;
    else
	var url ="moz-icon:file:///" + textbox.value + "?size=" + menulist.value;
    /*var size=16;
    if(menulist&&menulist.selectedIndex >0)
      size=32;
    if(url.match(/^moz-icon:.+/)){
      url=url.replace(/\?size\=[0-9][0-9]/g,"");
      url=url+"?size="+size.toString();
    }

    textbox.value=url;*/
    image.src=url;
  },

  freezeButton : function(flag){
    document.getAnonymousElementByAttribute(document.documentElement, "dlgtype", "extra1").disabled=flag;
  },

  invalidateWindows : function(){
		this.rdf.invalidateWindows();
  }
};